        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include "SMain.h"
#include "XMain.h"

#define	ERROR_STRING_LENGTH	500

int	quit_flag;

int 	ErrorHandler( unsigned function_code, int description, unsigned useful_number )
{
/****************************************************************************************
 * This is the Error Handler of the program. To sign in a function do:			*
 *	1. Add the function name to the all_functions[] list in the form shown		*
 *	2. Add a case statement as shown.						*
 *	3. Add a description of a NEW error in the ehandler.h header file		*
 * Fuction Calling is: function_code. Use the *all_fu.. list as a reference		*
 * Description is: description  of the error 						*
 * Useful number is: the number of chan failed or neuron etc 				* 
 * As an example consider the :								*
 *	ErrorHandler( 1,  ALLOCATE_CHANS, 5 );						*
 * means that an error ocured in function AllocateChans(1)				*
 * the problem was a channel allocation (ALLOCATE_CHANS) and the channel failed was #5  *
 * returns NOTHING									*
 * when the switch selection is finished it will exit ( using Quit) with an exit code   *
 * = description , however this can be avoided.						*
 * If U don't want to exit for some errors use a return instead of break		*
 ****************************************************************************************/



	int  	ret = TRUE;
	char	error_msg[ERROR_STRING_LENGTH];
	char 	*all_functions[] = {
		"NULL",
/* 1 */		"main",
		"AllocateChans",
		"ErrorHandler",
		"Quit",
		"FreeNeuronNode",
		"CreateNeuron",
		"GetRelativeOffset",
		"HiddenLayerProcessing",
		"f",
		"f_inv",

		"ParChanOut",
		"OutputLayerProcessing",
		"FeedInputLayer",
		"Random",
		"RandomInt",
		"prSER",
		"prIn",
		"prHL",
		"prOUT",
		"TransputerInitialize",

		"ErrorServer",
		"Initialize",
		"XInitialize",
		"CalculateStructSizes",
		"CreateButtonsOfControlPanel",
		"CreateTheSetupDialogBox",
		"CreateTheInputDialogBox",
		"CreateTheTrainingDialogBox",
		"CreateTheRunningDialogBox",
		"CreateTheFileopsDialogBox",

		"DrawTheNeuralNetwok",
		"TopLevelExposureHandler",
		"InputExposureHandler",
		"TrainingInputExposureHandler",
		"TrainingOutputExposureHandler",
		"InputWidgetEventHandler",
		"TrainingInpWidgetEventHandler",
		"TrainingOutWidgetEventHandler",
		"AboutRoutine",
		"SetupPopUpRoutine",

		"InputPopUpRoutine",
		"TrainingPopupRoutine",
		"RunningPopupRoutine",
		"FileopsPopupRoutine",
		"QuitRoutine",
		"SetupApplyRoutine",
		"SetupPopDownRoutine",
		"SetupHiddenDefaultRoutine",
		"SetupHiddenApplyRoutine",
		"SetupHiddenPopDownRoutine",

		"SetupDigAnaDefaultRoutine",
		"SetupDigAnaApplyRoutine",
		"SetupDigAnalPopDownRoutine",
		"InputPopDownRoutine",
		"InputApplyRoutine",
		"InputAllRoutine",
		"InputStartRoutine",
		"InputAnalogNextRoutine",
		"InputAnalogPreviousRoutine",
/*60*/		"TrainingPopDownRoutine",

		"TrainingStartRoutine",
		"TrainingAllInputRoutine",
		"TrainingAllOutputRoutine",
		"TrainingApplyRoutine",
		"TrainingApplySingleRoutine",
		"TrainingNextExemplarRoutine",
		"TrainingPreviousExemplarRoutine",
		"TrainingAnalogNextInputNodeRoutine",
		"TrainingAnalogNextOutputNodeRoutine",
		"TrainingAnalogNextExemplarRoutine",

		"TrainingAnalogPreviousExemplarRoutine",
		"RunningStartRoutine",
		"RunningPopdownRoutine",
		"CreateTheNeuralNetwork",
		"SetRandomValuesInNetwork",
		"FileopsQuitRoutine",
		"FileopsSaveParamsRoutine",
		"FileopsLoadParamsRoutine",
		"FileopsSaveTrainingRoutine",
/*80*/		"FileopsLoadTrainingRoutine",

		"PutColorMap",
		"VariablesMemoryAllocate",
		"Learning",
		"Examination",
		"Random",
		"IntRandom",
		"SparcInitialize",
		"FileopsByte2FloatRoutine",
		"InputFileLoadRoutine",
/*90*/		"ConversionsPopupRoutine",

		"InputFileStepRoutine",
		"InputFileAllRoutine",
		"InputFilePopupRoutine",
		"ShowImage"
		
	};

	quit_flag = FALSE;
	
	switch( (int )description ){
		case ALLOCATE_CHANS:
	 		sprintf( error_msg, "\n\n\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nProblem assigning a pointer value to channel '%u'.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n",
				 useful_number,all_functions[ function_code ] );
			DisplayError(error_msg);
			quit_flag = TRUE;
			break;
		case CREATE_NEURON_INP:
	 		sprintf( error_msg, "\n\n\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nProblem assigning a pointer value to the INPUT channel: '%u', of a  neuron.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, useful_number, all_functions[ function_code ] );
			DisplayError(error_msg);
			quit_flag = TRUE;
			break;
		case  CREATE_NEURON_OUT:
	 		sprintf( error_msg, "\n\n\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nProblem assigning a pointer value to the OUTPUT channel: '%u', of a neuron.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, useful_number,all_functions[ function_code ] );
			DisplayError(error_msg);
			quit_flag = TRUE;
			break;
		case MALLOC_ERROR:
	 		sprintf( error_msg, "\n\n\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nProblem allocating memory dynamically.\nThe actual function the error was detected in was '%s'( time used was %d ).\nFree memory and exit NOW ...\n"
			    ,useful_number,all_functions[ function_code ] );
			DisplayError(error_msg);
			quit_flag = TRUE;
			break;
		case OUT_OF_RANGE:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nOut of range parameters when calling function.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				,all_functions[ function_code ] );
                        DisplayError(error_msg);
			quit_flag = TRUE;
                        break;
		case PREVIOUS_NODE_ERROR:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nCannot find any previous node.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, all_functions[ function_code ] );
                        DisplayError(error_msg);
			quit_flag = TRUE;
                        break;
		case NEXT_NODE_ERROR:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nCannont find any next node.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, all_functions[ function_code ] );
                        DisplayError(error_msg);
			quit_flag = TRUE;
                        break;
		case WRONG_PARAMETERS:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nParameter or attribute is not known (%d).\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, useful_number, all_functions[ function_code ] );
                        DisplayError(error_msg);
/*			quit_flag = TRUE;*/
                        break;
		case  WRONG_PARAMETERS_MODIFY:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nTo convert byte2float you need only one output node.\nWhy don't you modify the output nodes setting in the SetUp poupu and try again?\n"
			,  all_functions[ function_code ] );
                        DisplayError(error_msg);
                        break;
		case CHANNEL_INPUT:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nFailed to read an input channel.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, all_functions[ function_code ] );
                        DisplayError(error_msg);
			quit_flag = TRUE;
                        break;
		case CHANNEL_OUTPUT:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nFailed to read an output channel.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, all_functions[ function_code ] );
                        DisplayError(error_msg);
			quit_flag = TRUE;
                        break;
		case ALLOCATE_PROC:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nFailed to allocate process.\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, all_functions[ function_code ] );
                        DisplayError(error_msg);
			quit_flag = TRUE;
                        break;
		case EMPTY_CHAN_LIST:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nPointer to empty list of channels.(Channel=%d)\nThe actual function the error was detected in was '%s'.\nFree memory and exit NOW ...\n"
				, useful_number,  all_functions[ function_code ] );
                        DisplayError(error_msg);
			quit_flag = TRUE;
                        break;
		case ACTION_TIMED_OUT:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nAction timed out or iterations in loop exceeded limit of %d.\nThe actual function the error was detected in was '%s'.\n"
				, useful_number, all_functions[ function_code ] );
			DisplayError(error_msg);
			XFlush(dpy);
			quit_flag = TRUE;
                        break;
		case CREATE_NEURON_NODE:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nFunction CreateNeuron returned NULL in layer %d.\nThe actual function the error was detected in was '%s'.\n"
				, useful_number, all_functions[ function_code ]);
			DisplayError(error_msg);
                        break;
		case NOT_MAPPED_YET:
                        sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nYou are trying to use layer without mapping it!!!.\nThe actual function the error was detected in was '%s'.\n"
				,  all_functions[ function_code ]);
			DisplayError(error_msg);
                        break;			
		case FILE_OPEN_ERROR:
			sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nCould not open file for reading/writing.\nThe actual function the error was detected in was '%s'.\n"
				,  all_functions[ function_code ]);
			DisplayError(error_msg);
                        break;			
		case UNEXPECTED_EOF:
			sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nEOF occured while reading data from file.\nThe actual function the error was detected in was '%s'.\n"
				,  all_functions[ function_code ]);
			DisplayError(error_msg);
                        break;			
		case UNEXPECTED_EOF_MODIFY:
			sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nEOF occured while reading training data from file.\nThis means that the data contained in that file is not sufficient\nto cover %d exemplars and %d input nodes.\nWhy don't you modify the 'exemplars' setting in the SetUp popup to the value: '%d', and try again?\nThe actual function the error was detected in was '%s'.\n"
				, num_exemplars, CFTable[0], useful_number,  all_functions[ function_code ]);
			DisplayError(error_msg);
                        break;			
		case FILE_WRITE_ERROR:
			sprintf( error_msg, "\n\n\t\t\t\tERROR HANDLER REPORTS:\n\t\t-----------------------------------------------------\nCould not write data to file.\nThe actual function the error was detected in was '%s'.\n"
				,  all_functions[ function_code ]);
			DisplayError(error_msg);
                        break;			
		default:
			sprintf( error_msg, "NOT YET IMPLEMENTED ERROR CODE = %d,\nUSEFUL NUMBER = %d,\nIN FUNCTION:' %s '.\n", description, useful_number, all_functions[ function_code ]);
			DisplayError(error_msg);
			break;
	}

	if( quit_flag == TRUE ) Quit(-1);
	return( ret );
		
}



void 	Quit( int exit_code )
{
/******************************************************************************************
 * Quit function must ensure a clean exit so free everything clear and exit		  *
 ******************************************************************************************/

	int lay, node;


	for(lay=0;lay<max_layers;lay++)
		for(node=0;node<CFTable[lay];node++)
			FreeNeuronData(NCP[lay][node]);


	exit( exit_code );

}

void FreeNeuronData( Neuron n )
{
	free(n->weight);
	free(n);
}

void	DisplayError(char *str)
{
	Arg	arg[4];
	int	i;
	char	asd[10];
	
        i = 0;
        XtSetArg(arg[i], XtNwidth, (Dimension )600);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )164);i++;
        XtSetArg(arg[i], XtNx, (Position )250);i++;
        XtSetArg(arg[i], XtNy, (Position )300);i++;
	XtSetValues( ErrorPopup, arg, i);

	XtVaSetValues(ErrorForm, XtNstring, str, NULL);
	
        
        XtPopupSpringLoaded( ErrorPopup );

	XtAddEventHandler( ErrorPopup, ButtonPressMask, FALSE, ErrorPressMouseToQuitEventHandler, (Opaque )NULL );

	XBell( dpy, 30 );
	XBell( dpy, 40 );
	XFlush(dpy);
}


void	ErrorPressMouseToQuitEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont )
{
	XtPopdown(ErrorPopup);

	if( quit_flag ) Quit(0);
}
