        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/uio.h>
#include <sys/fcntlcom.h>

#include "ErrorHandler.h"

typedef int BOOL;
typedef unsigned char BYTE;

#define strsave(s) (strcpy(malloc(strlen(s)+1),s))

#define	SHOW_IM_TEMP_FILE 	"/usr/tmp/.exemplars"
#define	SHOW_IM_TEMP_FILE_UN 	/usr/tmp/.exemplars
extern BYTE *orig;
extern BYTE orig1[116000];

#ifdef TRUE
#undef TRUE
#undef FALSE
#endif
#define TRUE		1
#define	FALSE		0


/* 	DEFINES		*/
#define TERM_NOT        (void *)0xFFF   /* termination number for alloc procs, chans */
#define INPUT		0
#define	LEARNING	1
#define EXAMINATION	2
#define MAX_WEIGHT	1.0 /* The maximum weight value that can be output from the random gen machine */
#define MAX_THRESH	1.1 /* The same for threshold values */



#define DISCRETE        'D'
#define CONTINUOUS      'C'


#define	RANDOM_ARRAY_LENGTH	1000
#define	SAFE_LINE		100000
#define INPUT_NODES_WIDTH       1
#define INPUT_NODES_HEIGTH      4
#define OUTPUT_NODES_WIDTH      1
#define OUTPUT_NODES_HEIGHT     2
#define INPUT_NODES             4
#define OUTPUT_NODES            2
#define HIDDEN_NODES            4
#define NUM_EXEMPLARS           2
#define MAX_LAYERS              3
#define	MAX_ITERS		25
#define BETA                    1.4
#define LAMDA                   1.0

/* MACROS AND VARIOUS TRICKS */
#define randomize(a) (srand( (unsigned )time(NULL) + a )) /* applies the time( up to second ) as seed to rand */
#define ABS(a)  (a < 0  ? (0 - (a)):a) /* absolute value coz the buildin abs is useless */
#define	ROUND_UP(a)	(double )( (int )(a+0.5) )


/* 	EXTERNAL VARIABLE AND TYPEDEFS	*/
struct 		NEURON {
        int     layer,
                node,
                inpnum,
                outnum;
        double  *weight,
                threshold,
                sigmoid,
                output,
                input, /* the sum of pr layer outputs*weights */
                delta;
	};

typedef struct NEURON   *Neuron;        /* A pointer to the structure NEURON for return reasons */


extern  double  OldError,
                OldRate,
                NormError,
                NormRate,
 		step,
		*examination,
		*single_output,
		Beta, Lamda,
		***SuperErrorMatrix,
		SuperError,
		*desired;

extern 	int 	max_layers, 	max_layers_OLD,	 /* the maximum number of layers shoulb be ddefined in MAIN	*/
		*CFTable,   			 /* says the max number of nodes in each layer*/
		num_exemplars,  num_exemplars_OLD,
		max_iters,
		vectors[100],
		iterations,
		*RNDArray,
		RandomPointer,
		DEBUG,
		RANDOM,
		*RandomVectorsArray,
		RequestedInterrupt;

struct 		TRAINING {
	double	*Target;
	double	*Input; 
		};

extern  struct 	TRAINING   	*Training, 
                		*AnalogTempTrainingData,
                		*DigitalTempTrainingData;

extern 	Neuron 	**NCP;       /* A one dimensional array of pointers each pointing to a structure NEURON containing data for any single neuron
			       that has been created and registered. the index to NCP is only one, therefore to implement the 2Dim array structure
			       (layer,node) we use the function GetRelativeOffset(layer,node). In this way we economize memory space since not all
			       the layers will have the same number of nodes.etc */

/* FLAGS */
extern	int     First_time_setup_flag,
       		CFT_has_changed_flag,
		ReplaceWeightsFlag;
        

/* 	ehandler.c	*/
extern 	int     ErrorHandler( unsigned function_code, int description, unsigned useful_number );
extern 	void 	Quit( int exit_code );
extern 	void 	FreeNeuronData( Neuron n );


extern	Neuron	    CreateNeuron( int layer, int node, int inpnum, int outnum );
                        
extern	void	ForwardPropagate( int exemplar );
extern	void	BackPropagate( int exemplar );  
extern	void	CalculateNewWeights( void );
extern	void	ErrorStatistics( int exemplar );
extern	double 	Random( double max );
extern  void	FillRandomArray( void );
extern	void    SparcInitialize( void );
extern	void    FeedInputs( int exemplar );
extern	double 	f( double input, double threshold );
extern	void	PutNoise( void );
extern	void	CreateTheNeuralNetwork(void);
extern	void    DisplayError( char *str );
extern	void	UpdateSuperErrorMatrix( void );
extern	void	ShowImage(char image_name[200], char data_file_name[200], int flag);
extern	int	*get_exemplar(int x1, int y1);
