
        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/


#include "SMain.h"
#include "XMain.h"

#define	MAX_NOISE_RATIO	0.1


void		FillRandomVectorsArray(void);

void	Learning( void )
{
        char    label[30];
	double  TotalError = 0.0,
                TotalRate  = 0.0,
		*Node_TE,
		*Node_TR,
		*Node_TE_old,
		result = 0.0;
	int	exemp = 0, node, out,
		PlotError, PlotRate,
		pr_node, cu_node, lay, count = 0, i, j, k;
	                                
	iterations = 0;
	out = CFTable[max_layers-1];

	if( (Node_TE=(double *)calloc(out, sizeof(double))) == NULL )
		ErrorHandler(83, MALLOC_ERROR, 0);
	if( (Node_TE_old=(double *)calloc(out, sizeof(double))) == NULL )
		ErrorHandler(83, MALLOC_ERROR, 0);
	if( (Node_TR=(double *)calloc(out, sizeof(double))) == NULL )
		ErrorHandler(83, MALLOC_ERROR, 1);

	for(i=0;i<num_exemplars;i++)	
		RandomVectorsArray[i] = i;

	while( (iterations++<max_iters) && !RequestedInterrupt ){
if( RANDOM )	FillRandomVectorsArray();
		for(node=0;node<out;node++) Node_TE[node] = 0.0;
		for(exemp=0;exemp<num_exemplars;exemp++){
			
			ForwardPropagate( RandomVectorsArray[exemp] );
	
			BackPropagate( RandomVectorsArray[exemp] );

			CalculateNewWeights();

			
		        for(node=0;node<out;node++){
				result 	       = (Training[exemp].Target[node] - (NCP[max_layers-1][node])->sigmoid) *
		        			 (Training[exemp].Target[node] - (NCP[max_layers-1][node])->sigmoid);
		        	Node_TE[node] += result;
		        	TotalError    += result;
		        }
		}  /* for EXEMP loop */

		
		for(node=0;node<CFTable[max_layers-1];node++){
			Node_TE[node] /= (double )(out * num_exemplars);
			Node_TR[node]  = (Node_TE[node] - Node_TE_old[node]) / step;
			Node_TE_old[node] = Node_TE[node];
			sprintf(label, "%4.6lf", Node_TE[node]);
        	        XtVaSetValues(RunningErrorAscBox[node], XtNstring,label, NULL);
                	sprintf(label, "%4.6lf", Node_TR[node]);
                	XtVaSetValues(RunningRateAscBox[node], XtNstring, label, NULL);
			Node_TE[node]  = 0;
		}
		
	        TotalError /= (double )(out * num_exemplars); /* mean square error */
		
	        sprintf(label, "%d", max_iters-iterations);
        	XtVaSetValues(RunningItersAscLab, XtNstring, label, NULL);
/*		if( iterations % 5 == 0 ) printf("TE = %4.4lf,  TR=%4.4lf at ITER = %d\n", TotalError, TotalRate, iterations);*/
        
		sprintf(label, "%4.6lf", TotalError);
                XtVaSetValues(RunningErrorAscBox[out], XtNstring,label, NULL);
                sprintf(label, "%4.6lf", TotalRate);
                XtVaSetValues(RunningRateAscBox[out], XtNstring, label, NULL);
		/* RunningRateAscBox and Error have out+1 elements : 0 to out-1 is for node errors and out is for toatal errors */

		TotalRate = (TotalError - OldError) / step; /* Dy/Dx */
	        if( iterations < 3 ){
                	NormError = ABS( 1.2*TotalError );
                	NormRate  = ABS( 1.2*TotalRate  );
		} else {
        	        PlotError = ERROR_BOX_Y -
                	            (int )(TotalError * ERROR_BOX_Y / NormError);
                	PlotRate  = (int )(ERROR_BOX_Y / 2) -
                        	    (int )(TotalRate * ERROR_BOX_Y / (2*NormRate));

	                XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), redgc,
        	                        (int )(step * (iterations -1)),
                	                ERROR_BOX_Y - (int )(ERROR_BOX_Y * (OldError  / NormError)),
					(int )(step * iterations),
					PlotError);
			XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), bluegc,
                                        (int )(step * (iterations -1)),
			                -(int )((ERROR_BOX_Y/2) * (OldRate / NormRate)) + (int )(ERROR_BOX_Y/2),
					(int )(step * iterations),
					PlotRate);
	                XFlush( dpy );
                }/* if iterations */

		OldError = TotalError;
               	OldRate  = TotalRate;
               	if( TotalError < SuperError  ) {
               		if( iterations > 3 ) {
				UpdateSuperErrorMatrix();
				SuperError = TotalError;
				ReplaceWeightsFlag = TRUE;
			}
		}
               	TotalError = 0.0;
	}/* while iterations */
	

	if( ReplaceWeightsFlag == TRUE ){
	        for(i=1;i<max_layers;i++){
        	        for(j=0;j<CFTable[i];j++)
                	        for(k=0;k<CFTable[i-1];k++)
					(NCP[i][j])->weight[k] = SuperErrorMatrix[i][j][k];
		}
	}
}


void	UpdateSuperErrorMatrix( void )
{
	int	i, j, k;

	for(i=1;i<max_layers;i++)
		for(j=0;j<CFTable[i];j++)
			for(k=0;k<CFTable[i-1];k++)
				SuperErrorMatrix[i][j][k] = (NCP[i][j])->weight[k];
}				


void	Examination( void )
{
	char 	label[30];
	int 	i, j, x, y;

	
	ForwardPropagate( -1 );
	
if( Type[0] == DISCRETE ){
        for(i=0;i<outwid;i++)
		for(j=0;j<outhei;j++)
			XFillRectangle( dpy, XtWindow( InputOutputForm ),
				WHICH_COLOR( (int )ROUND_UP(NCP[max_layers-1][i+j*outwid]->sigmoid) , redgc, whitegc),
				i*Sizes.output.box.x, j*Sizes.output.box.y,
				Sizes.output.box.x, Sizes.output.box.y);

	        /* draw the grid of black lines */
       		for(x=0;x<Sizes.output.window.x;x+=Sizes.output.box.x)
      			XDrawLine( dpy, XtWindow( InputOutputForm ), blackgc, x, 0, x, Sizes.output.window.y); /* vertical */
      		for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
	               	XDrawLine( dpy, XtWindow( InputOutputForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/

	XFlush(dpy);
} else {
	printf("OUTPUT IS:   ");
	for(i=0;i<CFTable[max_layers-1];i++){
		sprintf(label, "%4.4lf", NCP[max_layers-1][i]->sigmoid );
		XtVaSetValues( InputAnalogAscOutput[i], XtNstring, label, NULL );
                XFillRectangle( dpy, XtWindow( InputOutputForm ),
                        WHICH_COLOR( (int )ROUND_UP(NCP[max_layers-1][i]->sigmoid) , redgc, whitegc),
                        0, i*Sizes.output.box.y,
                        Sizes.output.box.x, Sizes.output.box.y);
                /* draw the grid of black lines horizontal */
		XFlush(dpy);
		printf("%d ",(int )ROUND_UP(NCP[max_layers-1][i]->sigmoid)); 
	}
       	for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
               	XDrawLine( dpy, XtWindow( InputOutputForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/
	XFlush(dpy);		
	printf("\nIT SHOULD BE:");
	for(i=0;i<CFTable[max_layers-1];i++) printf("%d ", (int )ROUND_UP(desired[i]));
	printf("\n\n");
} /* else Type */

	        	
}		

void	FillRandomArray( void )
{
	long	i = -1;
	
	srand( time(0) );
	
	while( ++i < RANDOM_ARRAY_LENGTH )
		RNDArray[i] = rand();

	RandomPointer = 0;
}

void	FillRandomVectorsArray(void)
{
	int	i, temp, index1, index2;
	
	for(i=0;i<num_exemplars;i++)	
		RandomVectorsArray[i] = i;

	/* now shuffle up the array */
	for(i=0;i<2*num_exemplars;i++){
		index1 = IntRandom(num_exemplars);
		temp   = RandomVectorsArray[index1];
		index2 = IntRandom(num_exemplars);
		RandomVectorsArray[index1] = RandomVectorsArray[index2];
		RandomVectorsArray[index2] = temp;
	}

}
	                         
double Random( double max )
{
	int 	safe = 0;
	double	random;

	max = ABS(max);
	if( max == 0 ) ErrorHandler(85, WRONG_PARAMETERS, 0);

	                 
	if( RandomPointer >= RANDOM_ARRAY_LENGTH ) FillRandomArray();
	
	random = (double )(RNDArray[ RandomPointer ]);

	/* problem with the rnd generator because last bit is not so random so check fourth or fifth bit */
	random = (double )( ((int )(random/10000) % 2) == 0   ?    -random:+random);
	do{
		random /= 2.0;
		if( safe++ > 40000 ) random = (double )(RNDArray[ RandomPointer ] / 10E+10);
	}  while( ABS(random) > (double )max );
	/* so we can have a random number lewss than the max defined */

	RandomPointer++;
	return( random );
}




int	IntRandom( int max )
{
	int 	safe = 0,
		random;
	
	if( RandomPointer >= RANDOM_ARRAY_LENGTH ) FillRandomArray();

	max = ABS(max);
	
	if( max == 0 ) ErrorHandler(86, WRONG_PARAMETERS, 0);
	
	random = (int )(RNDArray[ RandomPointer ] / 10000) % max;

	RandomPointer++;
	return( random );
}


void	SparcInitialize( void )
{
	SuperErrorMatrix = NULL;
	SuperError = 1.0;
	ReplaceWeightsFlag = FALSE;
	RandomVectorsArray = NULL;
	RequestedInterrupt = FALSE;
	RANDOM = FALSE;
	desired = NULL;

	max_layers_OLD = 0;
	num_exemplars  = 0;
	
	if( (RNDArray=(int *)calloc(RANDOM_ARRAY_LENGTH, sizeof(int))) == NULL )
		ErrorHandler(87, MALLOC_ERROR, 0);
		
	FillRandomArray();


}


void	PutNoiseInNetwork( Widget W, XtPointer client_data, XtPointer call_data )
{
	int	i, j, k;

	for(i=1;i<max_layers;i++)
		for(j=0;j<CFTable[i];j++)
			for(k=0;k<CFTable[i-1];k++)
				(NCP[i][j])->weight[k] += Random( (NCP[i][j])->weight[k] * MAX_NOISE_RATIO );
}				
