         /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include "XMain.h"
#include "SMain.h"

void	VariablesMemoryAllocate( void );
int	CFTable_OLD[200];

void	SetupPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data )
/* It will popup the setup sub menu */
{
	Arg		arg[5];
	char		dummy[2];
	int 		i=0;
	
 	
 	i = 0;
        XtSetArg(arg[i], XtNwidth, (Dimension )194);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )170);i++;
        XtSetArg(arg[i], XtNx, (Position )280);i++;
        XtSetArg(arg[i], XtNy, (Position )30);i++;
 	XtSetValues( SetupPopup, arg, i);

	dummy[0] = ( RANDOM == TRUE ? 'Y' : 'N' );
	dummy[1] = '\0';
	XtVaSetValues(SetupAscType, XtNstring, Type, NULL);
	XtVaSetValues(SetupAscRandom, XtNstring, dummy, NULL);
	XtVaSetValues(SetupAscExemplar, XtNstring, Exemplars, NULL);
	XtVaSetValues(SetupAscLayers, XtNstring, Layers, NULL);


 	XtPopupSpringLoaded( SetupPopup );

}


void	SetupPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	/* no need to get any values in quit. if user wants to take values then should do apply first */

	XtPopdown(SetupPopup);

}

void	SetupHiddenPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int	i;

	/* no need to get any values in quit. if user wants to take values then should do apply first */
        VariablesMemoryAllocate();
        CreateTheNeuralNetwork();
                
	for(i=0;i<max_layers-2;i++){
		XtDestroyWidget(SetupHiddenLab[i]);
		XtDestroyWidget(SetupHiddenAsc[i]);
	} /* from the hidden layer sub menu */
	free( SetupHiddenAsc );
	free( SetupHiddenLab );

	XtPopdown(SetupHiddenPopup);
	XtPopdown(SetupPopup);


	DrawTheNeuralNetwork();
	First_time_setup_flag = FALSE;
}

void	SetupDigAnaPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	/* no need to get any values in quit. if user wants to take values then should do apply first */
	XtPopdown(SetupDigAnaPopup);
}

void 	SetupApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[1];
	String	string;
	int 	i=0, j, *CFTemp;
	char	label[30];

        if( (CFTemp=(int *)calloc(max_layers, sizeof(int))) == NULL )
                ErrorHandler(46, MALLOC_ERROR, 0);
        for(i=0;i<max_layers;i++) CFTemp[i] = CFTable[i];

        /* Free the neural net mapping if already one exists */
        if( !First_time_setup_flag && !NCP )
                for(i=0;i<max_layers;i++)
                        for(j=0;j<CFTable[i];j++)
                                FreeNeuronData( NCP[i][j] );

		
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(SetupAscType, arg, 1);
	Type[0] = toupper(string[0]);
	if( (Type[0]!=DISCRETE) && (Type[0]!=CONTINUOUS) ) Type[0] = DISCRETE;

	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(SetupAscRandom, arg, 1);
	RANDOM = ( toupper(string[0]) == 'Y'  ?  TRUE : FALSE );


	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(SetupAscExemplar, arg, 1);
	strcpy(Exemplars,string); num_exemplars_OLD = num_exemplars;/*because free training and all */
	if( (num_exemplars=atoi(Exemplars)) == 0 ) num_exemplars = num_exemplars_OLD;
	 

	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(SetupAscLayers, arg, 1);
	strcpy(Layers,string);  max_layers_OLD = max_layers;
	if( (max_layers=atoi(Layers)) < 3 ) max_layers = max_layers_OLD;
	
	
	if( CFTable != NULL ){
		for(i=0;i<max_layers_OLD;i++) CFTable_OLD[i] = CFTable[i];
		free(CFTable);
	}
       	if( (CFTable=(int *)calloc(max_layers, sizeof(int))) == NULL )
       		ErrorHandler(46, MALLOC_ERROR, 1);
       	if( max_layers == max_layers_OLD )      for(i=0;i<max_layers;i++) CFTable[i] = CFTemp[i];
       	else {
		if( CFTemp[0] != INPUT_NODES ) CFT_has_changed_flag = TRUE;
       		CFTable[0] = INPUT_NODES;
       	        if( CFTemp[max_layers_OLD-1] != OUTPUT_NODES ) CFT_has_changed_flag = TRUE;
       	        CFTable[max_layers-1] = OUTPUT_NODES;
       	        for(i=1;i<max_layers-1;i++) CFTable[i] = HIDDEN_NODES;
	}

        free(CFTemp);
        
	SetupHiddenLab = (Widget *)calloc(atoi(Layers), sizeof(Widget));
	SetupHiddenAsc = (Widget *)calloc(atoi(Layers), sizeof(Widget));
        SetupHiddenPopup = XtVaCreatePopupShell("Hidden Layers", transientShellWidgetClass, toplevel,NULL);
        SetupHiddenForm  = XtVaCreateManagedWidget("SetupHiddenForm",boxWidgetClass, SetupHiddenPopup, NULL);
	for(i=0;i<max_layers-2;i++){
		sprintf(label, "Layer %d", i+1);
		SetupHiddenLab[i] = XtVaCreateManagedWidget(label,labelWidgetClass,SetupHiddenForm,XtNeditType, XawtextEdit,NULL);
		SetupHiddenAsc[i] = XtVaCreateManagedWidget(label,asciiTextWidgetClass,SetupHiddenForm,XtNeditType, XawtextEdit,NULL);
		if( Hidden[i][0] == NULL ) strcpy(Hidden[i],"4"); 
		XtVaSetValues(SetupHiddenAsc[i], XtNstring, Hidden[i], NULL);
	}
	i = 0;
        XtSetArg(arg[i], XtNwidth, (Dimension )180);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )23*max_layers+1);i++;
        XtSetArg(arg[i], XtNx, (Position )50);i++;
        XtSetArg(arg[i], XtNy, (Position )30);i++;
        XtSetValues( SetupHiddenPopup, arg, i);

	/* now make the quit and apply command buttons and set call backs */
	SetupHiddenQuitButton  = XtVaCreateManagedWidget("   Quit   ",commandWidgetClass,SetupHiddenForm,NULL);
	SetupHiddenApplyButton = XtVaCreateManagedWidget("   Apply   ",commandWidgetClass,SetupHiddenForm,NULL);
	/* and their call backs */
	XtAddCallback(SetupHiddenQuitButton,XtNcallback,SetupHiddenPopDownRoutine,NULL);
	XtAddCallback(SetupHiddenApplyButton,XtNcallback,SetupHiddenApplyRoutine,NULL);
	
 	XtPopupSpringLoaded( SetupHiddenPopup );

	if( Type[0] == DISCRETE ){
		SetupDigAnaPopup = XtVaCreatePopupShell("Digital Input/Output", transientShellWidgetClass, toplevel,NULL);
        	SetupDigAnaForm  = XtVaCreateManagedWidget("Digital Form Setup",boxWidgetClass, SetupDigAnaPopup, NULL);

		SetupDigAna[0] = XtVaCreateManagedWidget(" Input Height",labelWidgetClass,SetupDigAnaForm,NULL);
		SetupDigAna[4] = XtVaCreateManagedWidget("hello 1",asciiTextWidgetClass,SetupDigAnaForm,XtNeditType, XawtextEdit,NULL);

		SetupDigAna[1] = XtVaCreateManagedWidget(" Input Width ",labelWidgetClass,SetupDigAnaForm,NULL);
		SetupDigAna[5] = XtVaCreateManagedWidget("hello 2",asciiTextWidgetClass,SetupDigAnaForm,XtNeditType, XawtextEdit,NULL);

 		SetupDigAna[2] = XtVaCreateManagedWidget("Output Height",labelWidgetClass,SetupDigAnaForm,NULL);
		SetupDigAna[6] = XtVaCreateManagedWidget("hello 3",asciiTextWidgetClass,SetupDigAnaForm,XtNeditType, XawtextEdit,NULL);

		SetupDigAna[3] = XtVaCreateManagedWidget("Output Width ",labelWidgetClass,SetupDigAnaForm,NULL);
		SetupDigAna[7] = XtVaCreateManagedWidget("hello 3",asciiTextWidgetClass,SetupDigAnaForm,XtNeditType, XawtextEdit,NULL);

		XtVaSetValues(SetupDigAna[4], XtNstring, InpHei, NULL);
		XtVaSetValues(SetupDigAna[5], XtNstring, InpWid, NULL);
		XtVaSetValues(SetupDigAna[6], XtNstring, OutHei, NULL);
		XtVaSetValues(SetupDigAna[7], XtNstring, OutWid, NULL);
		
	 	i = 0;
	        XtSetArg(arg[i], XtNwidth, (Dimension )217);i++;
	        XtSetArg(arg[i], XtNheight, (Dimension )118);i++;
	        XtSetArg(arg[i], XtNx, (Position )280);i++;
		XtSetArg(arg[i], XtNy, (Position )230);i++;
 		XtSetValues( SetupDigAnaPopup, arg, i);

		SetupDigAnaQuitButton  = XtVaCreateManagedWidget("    Quit     ",commandWidgetClass,SetupDigAnaForm,NULL);
		SetupDigAnaApplyButton = XtVaCreateManagedWidget("    Apply    ",commandWidgetClass,SetupDigAnaForm,NULL);
		/* and their call backs */
		XtAddCallback(SetupDigAnaQuitButton,XtNcallback,SetupDigAnaPopDownRoutine,NULL);
		XtAddCallback(SetupDigAnaApplyButton,XtNcallback,SetupDigAnaApplyRoutine,NULL);

 		XtPopupSpringLoaded( SetupDigAnaPopup );
	} else {
		SetupDigAnaPopup = XtVaCreatePopupShell("Analog Input/Output", transientShellWidgetClass, toplevel,NULL);
        	SetupDigAnaForm  = XtVaCreateManagedWidget("Analog Form Setup",boxWidgetClass, SetupDigAnaPopup, NULL);

		SetupDigAna[0] = XtVaCreateManagedWidget("Input Nodes ",labelWidgetClass,SetupDigAnaForm,NULL);
		SetupDigAna[2] = XtVaCreateManagedWidget(label,asciiTextWidgetClass,SetupDigAnaForm,XtNeditType, XawtextEdit,NULL);

		SetupDigAna[1] = XtVaCreateManagedWidget("Output Nodes",labelWidgetClass,SetupDigAnaForm,NULL);
		SetupDigAna[3] = XtVaCreateManagedWidget(label,asciiTextWidgetClass,SetupDigAnaForm,XtNeditType, XawtextEdit,NULL);
		XtVaSetValues(SetupDigAna[2], XtNstring, InpNodes, NULL);
		XtVaSetValues(SetupDigAna[3], XtNstring, OutNodes, NULL);
		
	 	i = 0;
	        XtSetArg(arg[i], XtNwidth, (Dimension )208);i++;
	        XtSetArg(arg[i], XtNheight, (Dimension )72);i++;
	        XtSetArg(arg[i], XtNx, (Position )280);i++;
		XtSetArg(arg[i], XtNy, (Position )230);i++;
 		XtSetValues( SetupDigAnaPopup, arg, i);

		SetupDigAnaQuitButton  = XtVaCreateManagedWidget("   Quit     ",commandWidgetClass,SetupDigAnaForm,NULL);
		SetupDigAnaApplyButton = XtVaCreateManagedWidget("   Apply     ",commandWidgetClass,SetupDigAnaForm,NULL);
		/* and their call backs */
		XtAddCallback(SetupDigAnaQuitButton,XtNcallback,SetupDigAnaPopDownRoutine,NULL);
		XtAddCallback(SetupDigAnaApplyButton,XtNcallback,SetupDigAnaApplyRoutine,NULL);

		
		XtPopupSpringLoaded( SetupDigAnaPopup );
 	}
}

void 	SetupHiddenApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[1];
	String	string;
	int	i;

	for(i=0;i<max_layers-2;i++){
		XtSetArg(arg[0], XtNstring, &string);
		XtGetValues(SetupHiddenAsc[i], arg, 1);
		strcpy(Hidden[i],string);
		if( atoi(string) != 0 ) CFTable[i+1] = atoi(string);
		sprintf(Hidden[i], "%d", CFTable[i+1] );
	}

	VariablesMemoryAllocate();
	if( DEBUG )     printf("BEFORE num_exemplars = %d\nmax_layers = %d\ninpwid = %d\ninphei = %d\noutwid = %d\nouthei = %d\n",
				num_exemplars, max_layers, inpwid, inphei, outwid, outhei);
	if( DEBUG )     for(i=0;i<max_layers;i++) printf("CFTable[%d] = %d\n", i, CFTable[i]);

	CreateTheNeuralNetwork();

	for(i=0;i<max_layers-2;i++){
		XtDestroyWidget(SetupHiddenLab[i]);
		XtDestroyWidget(SetupHiddenAsc[i]);
	} /* from the hidden layer sub menu */
	free( SetupHiddenAsc );
	free( SetupHiddenLab );

	XtPopdown(SetupHiddenPopup);
	XtPopdown(SetupPopup);

	DrawTheNeuralNetwork();
	First_time_setup_flag = FALSE;
}

void 	SetupDigAnaApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[1];
	String	string;
	int	i, j, k, *CFTemp, inphei_OLD, outhei_OLD;


	if( (CFTemp=(int *)calloc(max_layers, sizeof(int))) == NULL )
		ErrorHandler(49, MALLOC_ERROR, 0);
	for(i=0;i<max_layers;i++) CFTemp[i] = CFTable[i];
	

	if( Type[0] == DISCRETE ){
		XtSetArg(arg[0], XtNstring, &string);
		XtGetValues(SetupDigAna[4], arg, 1);
		strcpy(InpHei,string);
		inphei_OLD = inphei;
		if( atoi(string) != 0 ) inphei = atoi(string);
		sprintf(InpHei, "%d", inphei);
		
		XtSetArg(arg[0], XtNstring, &string);
		XtGetValues(SetupDigAna[5], arg, 1);
		strcpy(InpWid,string);
		if( atoi(string) != 0 ) inpwid = atoi(string);
		sprintf(InpWid, "%d", inpwid);
		
		XtSetArg(arg[0], XtNstring, &string);
		XtGetValues(SetupDigAna[6], arg, 1);
		strcpy(OutHei,string);
		outhei_OLD = outhei;
		if( atoi(string) != 0 ) outhei = atoi(string);
		sprintf(OutHei, "%d", outhei);
		

		XtSetArg(arg[0], XtNstring, &string);
		XtGetValues(SetupDigAna[7], arg, 1);
		strcpy(OutWid,string);
		if( atoi(string) != 0 ) outwid = atoi(string);
		sprintf(OutWid, "%d", outwid);
		
		
		CFTable[0] 	      = inphei * inpwid;
		CFTable[max_layers-1] = outhei * outwid;
	} else {
		XtSetArg(arg[0], XtNstring, &string);
		XtGetValues(SetupDigAna[2], arg, 1);
		strcpy(InpNodes,string);
		if( atoi(string) != 0 ) CFTable[0] = atoi(InpNodes);
		sprintf(InpNodes, "%d", CFTable[0] );
		
		XtSetArg(arg[0], XtNstring, &string);
		XtGetValues(SetupDigAna[3], arg, 1);
		strcpy(OutNodes,string);
		if( atoi(string) != 0 ) CFTable[max_layers-1] = atoi(OutNodes);
		sprintf(OutNodes, "%d", CFTable[max_layers-1] );
	}

        for(i=0;i<max_layers;i++)
                if( CFTemp[i] != CFTable[i] ){
                	CFT_has_changed_flag = TRUE;
                	break;
                }

       	free(CFTemp);
	
	XtPopdown(SetupDigAnaPopup);

}


void	VariablesMemoryAllocate( void )
{
	int 	max_node = 0, i, j;

			
	if( SuperErrorMatrix != NULL ){
		for(i=1;i<max_layers_OLD;i++){
			for(j=0;j<CFTable_OLD[i];j++)
				free( SuperErrorMatrix[i][j] );
			free( SuperErrorMatrix[i] );
		}
	}	
	if( (SuperErrorMatrix=(double ***)calloc(max_layers, sizeof(double **))) == NULL )
		ErrorHandler(92, MALLOC_ERROR, 15);

	
	for(i=1;i<max_layers;i++){
		if( (SuperErrorMatrix[i]=(double **)calloc(CFTable[i], sizeof(double *))) == NULL )
			ErrorHandler(92, MALLOC_ERROR, 16);
		for(j=0;j<CFTable[i];j++){
			if( (SuperErrorMatrix[i][j]=(double *)calloc(CFTable[i-1], sizeof(double))) == NULL )
				ErrorHandler(92, MALLOC_ERROR, 17);
		}	
	}
/*	SuperErrorMatrix[0] = NULL;*/

	
		 

	/*****************************************************************************************/
	/* re malloc NCP allways, because is too much fuss to check if each entry in the CFTable has changed */
	i = -1;
	if( NCP ) while( NCP[++i] != NULL ) free(NCP[i]);

	if( (NCP=(Neuron **)calloc(max_layers, sizeof(Neuron *))) == NULL )
		ErrorHandler(92, MALLOC_ERROR, 13);
		
	for(i=0;i<max_layers;i++)
		if( (NCP[i]=(Neuron *)calloc(CFTable[i], sizeof(Neuron))) == NULL )
			ErrorHandler(92, MALLOC_ERROR, 14);
	/*****************************************************************************************/
	/* re malloc Training and D/ATTraData if any of the three conditions is true:
		(i)  The number of exemplars (num_exemplars)has changed, this affects the first field of the structure,
		(ii) The number of input nodes (CFT[0]) has changed, this affects the second-Input field,
		(iii)The number of output nodes (CFT[max-1]) has changed affects the second-Target field.
	   So OR i, ii, iii */
	if( (num_exemplars!=num_exemplars_OLD) || CFT_has_changed_flag || First_time_setup_flag ){
		if( Training != NULL ){
			for(i=0;i<num_exemplars_OLD;i++){
				free(Training[i].Target);
				free(Training[i].Input);
			}
		free( Training );
		}
		if( DigitalTempTrainingData != NULL ){
                	for(i=0;i<num_exemplars_OLD;i++){
                		free(DigitalTempTrainingData[i].Input);
                		free(DigitalTempTrainingData[i].Target);
                	}
        		free( DigitalTempTrainingData );
        	}
                if( AnalogTempTrainingData != NULL ){
                        for(i=0;i<num_exemplars_OLD;i++){
                                free(AnalogTempTrainingData[i].Input);
                                free(AnalogTempTrainingData[i].Target);
                        }
                        free( AnalogTempTrainingData );
                }
		/* Malloc the main pointer to the structure TRAINING */
		if( (Training 		= (struct TRAINING *)calloc(num_exemplars, sizeof(struct TRAINING))) == NULL )
			ErrorHandler(92, MALLOC_ERROR, 0);
		if( (DigitalTempTrainingData	= (struct TRAINING *)calloc(num_exemplars, sizeof(struct TRAINING))) == NULL )
			ErrorHandler(92, MALLOC_ERROR, 1);
		if( (AnalogTempTrainingData 	= (struct TRAINING *)calloc(num_exemplars, sizeof(struct TRAINING))) == NULL )
			ErrorHandler(92, MALLOC_ERROR, 2);
		/* Now malloc the 2 fields of the Training */
	        for(i=0;i<num_exemplars;i++){
        	        if( (Training[i].Input 		= (double *)calloc(CFTable[0]+1, sizeof(double))) == NULL )
				ErrorHandler(92, MALLOC_ERROR, 3);
			if( (DigitalTempTrainingData[i].Input= (double *)calloc(CFTable[0]+1, sizeof(double))) == NULL )
				ErrorHandler(92, MALLOC_ERROR, 4);
			if( (AnalogTempTrainingData[i].Input = (double *)calloc(CFTable[0]+1, sizeof(double))) == NULL )
				ErrorHandler(92, MALLOC_ERROR, 5);
 
			if( (Training[i].Target		     =(double *)calloc(CFTable[max_layers-1]+1, sizeof(double))) == NULL )
				ErrorHandler(92, MALLOC_ERROR, 6);
			if( (DigitalTempTrainingData[i].Target=(double *)calloc(CFTable[max_layers-1]+1, sizeof(double))) == NULL )
				ErrorHandler(92, MALLOC_ERROR, 7);
			if( (AnalogTempTrainingData[i].Target= (double *)calloc(CFTable[max_layers-1]+1, sizeof(double))) == NULL )
				ErrorHandler(92, MALLOC_ERROR, 8);
        	}
/*	        for(i=0;i<num_exemplars;i++){
        	        for(j=0;j<CFTable[0]+10;j++) Training[i].Input[j] = 0.0;
                	for(k=0;k<CFTable[max_layers-1]+10;k++) Training[i].Target[k] = 0.0;
        	} RESET???
*/
        } /* End malloc of struct TRAINING type */

	/*****************************************************************************************/
	/* The examination array will need re malloc if CFTable[0], input nodes, change */
        if( examination != NULL ) free( examination );  
	if( (examination=(double *)calloc(CFTable[0], sizeof(double))) == NULL )
		ErrorHandler(92, MALLOC_ERROR, 9);

	/*****************************************************************************************/
	/* the single_output array will need re malloc if the output number of nodes change */
	if( single_output != NULL ) free( single_output );
	if( (single_output=(double *)calloc(CFTable[max_layers-1], sizeof(double))) == NULL )
		ErrorHandler(92, MALLOC_ERROR, 10);

	/*****************************************************************************************/
	/* the Examination temporary arrays- one dimensional */
	if( DigitalTempExaminationData != NULL ) free( DigitalTempExaminationData );
	if( (DigitalTempExaminationData=(double *)calloc(CFTable[0], sizeof(double))) == NULL )
		ErrorHandler(92, MALLOC_ERROR, 11);
	for(i=0;i<CFTable[0];i++) DigitalTempExaminationData[ i ] = (double )WHITE;

	if( AnalogTempExaminationData != NULL )
	free( AnalogTempExaminationData );
	if( (AnalogTempExaminationData=(double *)calloc(CFTable[0], sizeof(double))) == NULL )
		ErrorHandler(92, MALLOC_ERROR, 12);

	if( RandomVectorsArray != NULL ) free( RandomVectorsArray );
	if( (RandomVectorsArray=(int *)calloc(num_exemplars, sizeof(int))) == NULL )
                ErrorHandler(92, MALLOC_ERROR, 13);

	Network_Not_Mapped = FALSE; /* now the net has been mapped in memory */

	/* malloc the desired output of testing */
	if( desired != NULL ) free(desired);
	if( (desired=(double *)calloc(CFTable[max_layers-1], sizeof(double))) == NULL )
		ErrorHandler(92, MALLOC_ERROR, 18);
}


