        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/


#include "XMain.h"
#include "SMain.h"


void	TrainingPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg		arg[10];
	int 		i=0, j, k,a,b;
	char 		str[20];

if( Network_Not_Mapped) {
	        ErrorHandler(42, NOT_MAPPED_YET, 0);
	                return;
}

if( Type[0] == DISCRETE ){

	i = 0;
	CalculateStructSizes();
	XtSetArg(arg[i], XtNwidth, (Dimension )109);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )213);i++;
 	XtSetArg(arg[i], XtNx, (Position )10);i++;
 	XtSetArg(arg[i], XtNy, (Position )20);i++;
 	XtSetValues( TrainingPopup, arg, i);


	i = 0;
 	XtSetArg(arg[i], XtNwidth, (Dimension )Sizes.input.window.x);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )Sizes.input.window.y);i++;
 	XtSetArg(arg[i], XtNx, (Position )220);i++;
 	XtSetArg(arg[i], XtNy, (Position )20);i++;
 	XtSetValues( TrainingInpCanvasPopup, arg, i);

	i = 0;
 	XtSetArg(arg[i], XtNwidth, (Dimension )Sizes.output.window.x);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )Sizes.output.window.y);i++;
 	XtSetArg(arg[i], XtNx, (Position)(220+20+Sizes.input.window.x));i++;
 	XtSetArg(arg[i], XtNy, (Position )20);i++;
 	XtSetValues( TrainingOutCanvasPopup, arg, i);

 	strcpy(str," Exemplar: 0");
	XtVaSetValues(TrainingAscExemplar, XtNstring, str, NULL);
	XtPopup( TrainingPopup,XtGrabNonexclusive );
	XtPopup( TrainingInpCanvasPopup, XtGrabNonexclusive ); /* so i can access both windows otherwise it blocks */
	XtPopup( TrainingOutCanvasPopup, XtGrabNonexclusive );

	


	XtAddEventHandler( TrainingInpCanvasPopup, ButtonPressMask, FALSE, TrainingInpWidgetEventHandler, (Opaque )NULL );
	XtAddEventHandler( TrainingOutCanvasPopup, ButtonPressMask, FALSE, TrainingOutWidgetEventHandler, (Opaque )NULL );

	XtAddEventHandler(TrainingInpCanvasForm, ExposureMask, False, TrainingInputExposureHandler, NULL);
	XtAddEventHandler(TrainingOutCanvasForm, ExposureMask, False, TrainingOutputExposureHandler, NULL);


	for(i=0;i<num_exemplars;i++){
		for(j=0;j<CFTable[0];j++) DigitalTempTrainingData[i].Input[j] = Training[i].Input[j];
		for(k=0;k<CFTable[max_layers-1];k++) DigitalTempTrainingData[i].Input[k] = Training[i].Target[k];
	}
	
	
} else {
	i = 0;

	XtSetArg(arg[i], XtNwidth, (Dimension )325);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )250);i++;
 	XtSetArg(arg[i], XtNx, (Position )50);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( TrainingAnalogPopup, arg, i);

	strcpy(str,"INP Node:0 ");
        XtVaSetValues(TrainingAnalogAscInputNode, XtNstring, str, NULL);
	strcpy(str,"OUT Node:0 ");
        XtVaSetValues(TrainingAnalogAscOutputNode, XtNstring, str, NULL);
       	strcpy(str,"Exemplar:0 ");
        XtVaSetValues(TrainingAnalogAscExemplar, XtNstring, str, NULL);

	sprintf(str, "%lf", Training[0].Input[0]);
        XtVaSetValues(TrainingAnalogInputAscBox, XtNstring, str, NULL);
	sprintf(str, "%lf", Training[0].Target[0]);
        XtVaSetValues(TrainingAnalogOutputAscBox, XtNstring, str, NULL);

	for(i=0;i<num_exemplars;i++){
		for(j=0;j<CFTable[0];j++) AnalogTempTrainingData[i].Input[j] = Training[i].Input[j];
		for(k=0;k<CFTable[max_layers-1];k++) AnalogTempTrainingData[i].Target[k] = Training[i].Target[k];
	}
	
	
	XtPopupSpringLoaded( TrainingAnalogPopup );
}	
}

void	TrainingNextExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	char str[10];
	int i, j, x,y;
	
/*wont save existing pattern this is done when apply single is pressed */
	sprintf(str, "Exemplar: %d", (ExemplarPointer>=(num_exemplars-1) ? (ExemplarPointer *= 0):++ExemplarPointer) );
	XtVaSetValues(TrainingAscExemplar, XtNstring, str, NULL);
		
	for(i=0;i<inpwid;i++)
		for(j=0;j<inphei;j++)
			XFillRectangle( dpy, XtWindow( TrainingInpCanvasForm ), WHICH_COLOR( Training[ExemplarPointer].Input[i+j*inpwid], redgc, whitegc), i*Sizes.input.box.x, j*Sizes.input.box.y, Sizes.input.box.x, Sizes.input.box.y);
	for(i=0;i<outwid;i++)
		for(j=0;j<outhei;j++)
			XFillRectangle( dpy, XtWindow( TrainingOutCanvasForm ), WHICH_COLOR( Training[ExemplarPointer].Target[i+j*outwid], redgc, whitegc), i*Sizes.output.box.x, j*Sizes.output.box.y, Sizes.output.box.x, Sizes.output.box.y);

/*load new */	for(j=0;j<CFTable[0];j++)
			DigitalTempTrainingData[ExemplarPointer].Input[j] = Training[ExemplarPointer].Input[j];
		for(j=0;j<CFTable[max_layers-1];j++)
			DigitalTempTrainingData[ExemplarPointer].Target[j] = Training[ExemplarPointer].Target[j];
	
	/* draw the grid of black lines */
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/

	for(x=0;x<Sizes.output.window.x;x+=Sizes.output.box.x)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, x, 0, x, Sizes.output.window.y); /* vertical */
	for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/
	
	XFlush(dpy);
}


void	TrainingPreviousExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	char str[10];
	int i, j, x,y;
	
	sprintf(str, "Exemplar: %d", (ExemplarPointer<=0 ? (ExemplarPointer+=(num_exemplars-1)):--ExemplarPointer) );
	XtVaSetValues(TrainingAscExemplar, XtNstring, str, NULL);
		
	for(i=0;i<inpwid;i++)
		for(j=0;j<inphei;j++)
			XFillRectangle( dpy, XtWindow( TrainingInpCanvasForm ), WHICH_COLOR( Training[ExemplarPointer].Input[i+j*inpwid], redgc, whitegc), i*Sizes.input.box.x, j*Sizes.input.box.y, Sizes.input.box.x, Sizes.input.box.y);
	for(i=0;i<outwid;i++)
		for(j=0;j<outhei;j++)
		XFillRectangle( dpy, XtWindow( TrainingOutCanvasForm ), WHICH_COLOR( Training[ExemplarPointer].Target[i+j*outwid], redgc, whitegc), i*Sizes.output.box.x, j*Sizes.output.box.y, Sizes.output.box.x, Sizes.output.box.y);

	for(j=0;j<CFTable[0];j++)
		DigitalTempTrainingData[ExemplarPointer].Input[j] = Training[ExemplarPointer].Input[j];

	for(j=0;j<CFTable[max_layers-1];j++)
		DigitalTempTrainingData[ExemplarPointer].Target[j] = Training[ExemplarPointer].Target[j];
	
	/* draw the grid of black lines */
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/

	for(x=0;x<Sizes.output.window.x;x+=Sizes.output.box.x)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, x, 0, x, Sizes.output.window.y); /* vertical */
	for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/
	
	XFlush(dpy);
}

void	TrainingPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{

	if( Type[0] == DISCRETE ){
		XtPopdown( TrainingOutCanvasPopup);
		XtPopdown( TrainingInpCanvasPopup);
		XtPopdown( TrainingPopup);
	} else  XtPopdown( TrainingAnalogPopup );
}

void	TrainingInputExposureHandler( Widget w, caddr_t unused, register XEvent *event)
{
	int i, j, x, y;

	/* draw the vector exactly as it was last time */
	for(i=0;i<inpwid;i++)
		for(j=0;j<inphei;j++)
			XFillRectangle( dpy, XtWindow( TrainingInpCanvasForm ), WHICH_COLOR((int )DigitalTempTrainingData[ExemplarPointer].Input[i+j*inpwid], redgc, whitegc), i*Sizes.input.box.x, j*Sizes.input.box.y, Sizes.input.box.x, Sizes.input.box.y);
			
	/* draw the grid of black lines */
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
		
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/
	
	XFlush(dpy);
}


void	TrainingOutputExposureHandler( Widget w, caddr_t unused, register XEvent *event)
{
	int i, j, x, y;

	/* draw the vector exactly as it was last time */
	for(i=0;i<outwid;i++)
		for(j=0;j<outhei;j++)
			XFillRectangle( dpy, XtWindow( TrainingOutCanvasForm ), WHICH_COLOR((int )DigitalTempTrainingData[ExemplarPointer].Target[i+j*inpwid], redgc, whitegc), i*Sizes.output.box.x, j*Sizes.output.box.y, Sizes.output.box.x, Sizes.output.box.y);
			
	/* draw the grid of black lines */
	for(x=0;x<Sizes.output.window.x;x+=Sizes.output.box.x)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, x, 0, x, Sizes.output.window.y); /* vertical */
		
	for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/
	
	XFlush(dpy);
}

void	TrainingInpWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont )
{
	int x, y, box;

	x = event->xbutton.x / Sizes.input.box.x;
	y = event->xbutton.y / Sizes.input.box.y; /* the box we are in */
	box = x + y*inpwid;
	
	if( (int )DigitalTempTrainingData[ExemplarPointer].Input[box] ==  WHITE ){
		XFillRectangle( dpy, XtWindow( TrainingInpCanvasForm ), redgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		XDrawRectangle( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		DigitalTempTrainingData[ExemplarPointer].Input[box] = (double )RED;
	} else {
		XFillRectangle( dpy, XtWindow( TrainingInpCanvasForm ), whitegc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		XDrawRectangle( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		DigitalTempTrainingData[ExemplarPointer].Input[box] = (double )WHITE;
	}
	
	XFlush(dpy);

}

void	TrainingOutWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont )
{
	int x, y, box;

	x = event->xbutton.x / Sizes.output.box.x;
	y = event->xbutton.y / Sizes.output.box.y; /* the box we are in */
	box = x + y*outwid;
	
	if( (int )DigitalTempTrainingData[ExemplarPointer].Target[box] ==  WHITE ){
		XFillRectangle( dpy, XtWindow( TrainingOutCanvasForm ), redgc, x*Sizes.output.box.x, y*Sizes.output.box.y,Sizes.output.box.x, Sizes.output.box.y);
		XDrawRectangle( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, x*Sizes.output.box.x, y*Sizes.output.box.y,Sizes.output.box.x, Sizes.output.box.y);
		DigitalTempTrainingData[ExemplarPointer].Target[box] = (double )RED;
	} else {
		XFillRectangle( dpy, XtWindow( TrainingOutCanvasForm ), whitegc, x*Sizes.output.box.x, y*Sizes.output.box.y,Sizes.output.box.x, Sizes.output.box.y);
		XDrawRectangle( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, x*Sizes.output.box.x, y*Sizes.output.box.y,Sizes.output.box.x, Sizes.output.box.y);
		DigitalTempTrainingData[ExemplarPointer].Target[box] = (double )WHITE;
	}

	XFlush(dpy);

}


void	TrainingStartRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int i, j, x, y;

	/* draw the vector exactly as it was last time BOTH IN THE INP AND OUT CANVAS*/
	for(i=0;i<inpwid;i++)
		for(j=0;j<inphei;j++)
			XFillRectangle( dpy, XtWindow( TrainingInpCanvasForm ), WHICH_COLOR( Training[ExemplarPointer].Input[i+j*inpwid], redgc, whitegc), i*Sizes.input.box.x, j*Sizes.input.box.y, Sizes.input.box.x, Sizes.input.box.y);
	for(i=0;i<outwid;i++)
		for(j=0;j<outhei;j++)
			XFillRectangle( dpy, XtWindow( TrainingOutCanvasForm ), WHICH_COLOR( Training[ExemplarPointer].Target[i+j*outwid], redgc, whitegc), i*Sizes.output.box.x, j*Sizes.output.box.y, Sizes.output.box.x, Sizes.output.box.y);

	for(i=0;i<num_exemplars;i++)
		for(j=0;j<CFTable[0];j++)
			DigitalTempTrainingData[i].Input[j] = Training[i].Input[j];
	for(i=0;i<num_exemplars;i++)
		for(j=0;j<CFTable[max_layers-1];j++)
			DigitalTempTrainingData[i].Target[j] = Training[i].Target[j];
	
	/* draw the grid of black lines */
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/

	for(x=0;x<Sizes.output.window.x;x+=Sizes.output.box.x)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, x, 0, x, Sizes.output.window.y); /* vertical */
	for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/
	
	XFlush(dpy);

}
	
void	TrainingAllInputRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	/* all black press all white for input box */
	int i, x, y;

	AllInpFlag = NOT(AllInpFlag);
	
	XFillRectangle( dpy, XtWindow( TrainingInpCanvasForm ), WHICH_COLOR(AllInpFlag, redgc, whitegc), 0,0, Sizes.input.window.x, Sizes.input.window.y);
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( TrainingInpCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/

		for(i=0;i<CFTable[0];i++)
			DigitalTempTrainingData[ExemplarPointer].Input[i] = (double )AllInpFlag;

	XFlush(dpy);
}

void	TrainingAllOutputRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	/* all black press all white for output box */
	int i, x, y;

	AllOutFlag = NOT(AllOutFlag);
	
	XFillRectangle( dpy, XtWindow( TrainingOutCanvasForm ), WHICH_COLOR(AllOutFlag, redgc, whitegc), 0,0, Sizes.output.window.x, Sizes.output.window.y);
	for(x=0;x<Sizes.output.window.x;x+=Sizes.output.box.x)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, x, 0, x, Sizes.output.window.y); /* vertical */
	for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
		XDrawLine( dpy, XtWindow( TrainingOutCanvasForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/

		for(i=0;i<CFTable[max_layers-1];i++)
			DigitalTempTrainingData[ExemplarPointer].Target[i] = (double )AllOutFlag;
			
	XFlush(dpy);

}
void	TrainingApplySingleRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int i;
	
if( Type[0] == DISCRETE ){
	for(i=0;i<CFTable[0];i++)
		Training[ExemplarPointer].Input[i] =
		DigitalTempTrainingData[ExemplarPointer].Input[i];
			
	for(i=0;i<CFTable[max_layers-1];i++)
		Training[ExemplarPointer].Target[i] =
		DigitalTempTrainingData[ExemplarPointer].Target[i];
}
/* do not popdown though */
}


void	TrainingApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int i, j, k;
	
if( Type[0] == DISCRETE ){
	for(i=0;i<num_exemplars;i++){
		for(j=0;j<CFTable[0];j++) Training[i].Input[j] = DigitalTempTrainingData[i].Input[j];
		for(k=0;k<CFTable[0];k++) Training[i].Target[k] = DigitalTempTrainingData[i].Target[k];
	}
	XtPopdown( TrainingOutCanvasPopup);
	XtPopdown( TrainingInpCanvasPopup);
	XtPopdown( TrainingPopup);
} else {
	for(i=0;i<num_exemplars;i++){
		for(j=0;j<CFTable[0];j++) Training[i].Input[j] = AnalogTempTrainingData[i].Input[j];
	        for(k=0;k<CFTable[0];k++) Training[i].Target[k]= AnalogTempTrainingData[i].Target[k];
	}
	XtPopdown( TrainingAnalogPopup );
}

}

void	TrainingAnalogNextInputNodeRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{

	Arg	arg[1];
	String	string;
	char	str[20];
	int  new_pointer;
	
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(TrainingAnalogInputAscBox, arg, 1);
	AnalogTempTrainingData[ ExemplarPointer ].Input[ AnalogNodePointerInput ]  = atof(string);

	new_pointer = ( AnalogNodePointerInput>=(CFTable[0]-1) ? AnalogNodePointerInput-=(CFTable[0]-1):++AnalogNodePointerInput);
	sprintf(str, "%lf",AnalogTempTrainingData[ ExemplarPointer ].Input[ new_pointer ] );
	XtVaSetValues(TrainingAnalogInputAscBox, XtNstring, str, NULL);	

	sprintf(str, "INP Node:%d ", AnalogNodePointerInput);
	XtVaSetValues(TrainingAnalogAscInputNode, XtNstring, str, NULL);
}


void	TrainingAnalogNextOutputNodeRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[1];
	String	string;
	char	str[20];
	int new_pointer;
	
/*save*/
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(TrainingAnalogOutputAscBox, arg, 1);
	AnalogTempTrainingData[ ExemplarPointer ].Target[ AnalogNodePointerOutput ]  = atof(string);

/*advance*/
	new_pointer = ( AnalogNodePointerOutput>=(CFTable[max_layers-1]-1) ? AnalogNodePointerOutput-=(CFTable[max_layers-1]-1):++AnalogNodePointerOutput);

/*print new info */
	sprintf(str, "%lf",AnalogTempTrainingData[ ExemplarPointer ].Target[ new_pointer ] );
	XtVaSetValues(TrainingAnalogOutputAscBox, XtNstring, str, NULL);	

	sprintf(str, "OUT Node:%d ", AnalogNodePointerOutput);
	XtVaSetValues(TrainingAnalogAscOutputNode, XtNstring, str, NULL);
}

		
void	TrainingAnalogNextExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[1];
	String	string;
	char	str[20];
	int	new_pointer, i, j;

	
/*save what is in the input box */
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(TrainingAnalogInputAscBox, arg, 1);
	AnalogTempTrainingData[ ExemplarPointer ].Input[AnalogNodePointerInput] = atof(string); /* store existing string */

	
/*save what is in the output box*/
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(TrainingAnalogOutputAscBox, arg, 1);
	AnalogTempTrainingData[ ExemplarPointer ].Target[AnalogNodePointerOutput] = atof(string); /* store existing string */

/* advance the common exemplarpointer and reset the two node pointers */
	new_pointer = (ExemplarPointer >= (num_exemplars-1)  ?  (ExemplarPointer*=0):(++ExemplarPointer));
	AnalogNodePointerInput = AnalogNodePointerOutput = 0;
	
/*put in the box the new values of inp/out exemp*/
	sprintf(str, "%lf",AnalogTempTrainingData[new_pointer].Input[0]);
	XtVaSetValues(TrainingAnalogInputAscBox, XtNstring, str, NULL);	

	sprintf(str, "%lf",AnalogTempTrainingData[new_pointer].Target[0]);
	XtVaSetValues(TrainingAnalogOutputAscBox, XtNstring, str, NULL);	

/* update pointer boxes */
	strcpy(str, "INP Node:0 ");
	XtVaSetValues(TrainingAnalogAscInputNode, XtNstring, str, NULL);

	strcpy(str, "OUT Node:0 ");
	XtVaSetValues(TrainingAnalogAscOutputNode, XtNstring, str, NULL);

	sprintf(str, "Exemplar: %d", ExemplarPointer);
	XtVaSetValues(TrainingAnalogAscExemplar, XtNstring, str, NULL);

}


void	TrainingAnalogPreviousExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[1];
	String	string;
	char	str[20];
	int	new_pointer;
	
/*save what is in the input box */
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(TrainingAnalogInputAscBox, arg, 1);
	AnalogTempTrainingData[ ExemplarPointer ].Input[AnalogNodePointerInput] = atof(string); /* store existing string */

/*save what is in the output box*/
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(TrainingAnalogOutputAscBox, arg, 1);
	AnalogTempTrainingData[ ExemplarPointer ].Target[AnalogNodePointerOutput] = atof(string); /* store existing string */

/* advance the common exemplarpointer and reset the two node pointers */
	new_pointer = (ExemplarPointer <= 0  ?  (ExemplarPointer+=(num_exemplars-1)):(--ExemplarPointer));
	AnalogNodePointerInput = AnalogNodePointerOutput = 0;
	
/*put in the box the new values of inp/out exemp*/
	sprintf(str, "%lf",AnalogTempTrainingData[new_pointer].Input[0]);
	XtVaSetValues(TrainingAnalogInputAscBox, XtNstring, str, NULL);	

	sprintf(str, "%lf",AnalogTempTrainingData[new_pointer].Target[0]);
	XtVaSetValues(TrainingAnalogOutputAscBox, XtNstring, str, NULL);	

/* update pointer boxes */
	strcpy(str, "INP Node:0 ");
	XtVaSetValues(TrainingAnalogAscInputNode, XtNstring, str, NULL);

	strcpy(str, "OUT Node:0 ");
	XtVaSetValues(TrainingAnalogAscOutputNode, XtNstring, str, NULL);

	sprintf(str, "Exemplar: %d", ExemplarPointer);
	XtVaSetValues(TrainingAnalogAscExemplar, XtNstring, str, NULL);
}


