         /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/


#include "XMain.h"
#include "TMain.h"

void prSER(Process *p, int attrib, char type)
{
	p = p;

	ErrorServer(attrib, type);
}

void prIN(Process *p, int attrib)
{
        p = p;

        FeedInputLayer( attrib );

}


void prHL( Process *p, int layer, int node, int attrib )
{
        p = p;

        HiddenLayerProcessing( NCP[GetRelativeOffset(layer,node)], layer, node, attrib );

}
                
        
void prOUT(Process *p, int node, double *target, int vector_num,  int attrib)
{
        p = p;

        OutputLayerProcessing( NCP[GetRelativeOffset(max_layers-1,node)], node, target, vector_num, attrib);

}


PrintNeuron( Neuron a )
{       
        int i;
               
        printf("\nNODE (%d,%d) has a pointer: %p\n",a->layer, a->node, a);
        printf("IN CHANS(%d): ", a->inpnum);
        for(i=0;i<a->inpnum;i++) printf(" %p, ",a->inp[i]);
        printf("\nOU CHANS(%d): ", a->outnum);
        for(i=0;i<a->outnum;i++) printf(" %p, ",a->out[i]);
        printf("\nWEIGHTS: ");
        for(i=0;i<a->inpnum;i++) printf(" %lf, ",a->weight[i]);
        printf("\nTHRESHOLD: %lf\n", a->threshold);
        if( (a->layer == 0) && (a->node == 0) ){
                         printf("seed:");
                for(i=0;i<CFTable[max_layers-1];i++)
                         printf("%p",a->seed[i]);
        
        }
        if( (a->layer == max_layers-1) ) printf("\nseed:%p\n",a->seed[0]);
        
 }
 
double Random( double max )
{
        double  rnd;
        int count = 0,i;
        
        ProcWait(400);
        for(i=0;i<1000;i++);
        
        srand( ProcTime() );
        rnd = rand();
 
        srand( ProcTime() + 10 );
        rnd =  ( (rand() % 2) == 0  ?   -rnd : rnd );
        
        do{
                rnd /= 2.0;
                if( count++ > 40000 ) rnd = rand() / 10E+10;
        } while( ABS(rnd) > (double )max );
                         
        return( rnd );
         
}
        
int RandomInt( int max_limit )
{
        ProcWait(455);
        
        srand( ProcTime() );
  
        return( rand() % max_limit );
}       
        
ResetNeuronChannels( Neuron n )
{       
        int i;

	if( !CRESET ) return;
        
        for(i=0;i<(n->inpnum);i++)      ChanReset( n->inp[i] );
        
        for(i=0;i<(n->outnum);i++)      ChanReset( n->out[i] );
  
}       

void    CreateTheNeuralNetwork( void )
{
        Neuron  n = NULL;
        int     i = 0, j;


	if( (n=(Neuron )calloc(1, sizeof(struct NEURON))) == NULL )
		ErrorHandler(74, MALLOC_ERROR, 0);

	
        for(i=0;i<CFTable[0];i++){
                if( (n=CreateNeuron(0,i,1,CFTable[1])) == NULL )
                        ErrorHandler(74, CREATE_NEURON_NODE, 0);
                ResetNeuronChannels(n);
                if( FALSE )     PrintNeuron(n);
        }

        /* Hidden layer(s) */
        for(i=1;i<=max_layers-2;i++)
                for(j=0;j<CFTable[i];j++) {
                        if( (n=CreateNeuron(i,j,CFTable[i-1],CFTable[i+1])) == NULL )
                                ErrorHandler(74, CREATE_NEURON_NODE, i);
                       	ResetNeuronChannels(n);
                        if( FALSE )             PrintNeuron(n);
                }

        /* The output nodes  must have inputs as many as the previous node , they must have only one output though */
        for(i=0;i<CFTable[max_layers-1];i++){
                 if( (n=CreateNeuron(max_layers-1, i, CFTable[max_layers-2], 1)) == NULL )
                                ErrorHandler(74, CREATE_NEURON_NODE, max_layers-1);
                ResetNeuronChannels(n);
                if( FALSE )     PrintNeuron(n);
        }

	if( RandomVector ) free(RandomVector);
	if( (RandomVector=(int *)calloc(num_exemplars+11, sizeof(int))) == NULL )
		ErrorHandler(74, MALLOC_ERROR, 1);
	for(i=0;i<num_exemplars+10;i++)
		RandomVector[i] = RandomInt(num_exemplars);		
}

void    TransputerInitialize( void )
{
	int 	i;

	CRESET = FALSE;
	DEBUG  = FALSE;

	RandomVector = NULL;
        if( (message=ChanAlloc()) == NULL)
                ErrorHandler(20, ALLOCATE_CHANS, 0);
                
}
 

