        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/


#include "XMain.h"
#include "TMain.h"

void	RunningPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg             arg[10];
        int             i=0, out;
        char            label[20];
	
if( Network_Not_Mapped) {
        ErrorHandler(43, NOT_MAPPED_YET, 0);
        return;
}

	out = CFTable[max_layers-1];
	
        RunningNodeAscLab  = (Widget *)calloc(out, sizeof(Widget));
        RunningRateAscBox  = (Widget *)calloc(out, sizeof(Widget));
        RunningErrorAscBox = (Widget *)calloc(out, sizeof(Widget));

	strcpy(label,"50");max_iters = 50; 
	XtVaSetValues(RunningItersAscLab, XtNstring, label, NULL);

	i = 0;        
        XtSetArg(arg[i], XtNwidth, (Dimension )323);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )(24*CFTable[max_layers-1] + 75));i++;
        XtSetArg(arg[i], XtNx, (Position )10);i++;
        XtSetArg(arg[i], XtNy, (Position )10);i++;
        XtSetValues( RunningPopup, arg, i);

       	i = 0;        
        XtSetArg(arg[i], XtNwidth, (Dimension )ERROR_BOX_X);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )ERROR_BOX_Y);i++;
        XtSetArg(arg[i], XtNx, (Position )350);i++;
        XtSetArg(arg[i], XtNy, (Position )10);i++;
        XtSetValues( RunningErrorCanvasPopup, arg, i);

/*	i = 0;        
        XtSetArg(arg[i], XtNwidth, (Dimension )600);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )400);i++;
        XtSetArg(arg[i], XtNx, (Position )350);i++;
        XtSetArg(arg[i], XtNy, (Position )450);i++;
        XtSetValues( RunningRateCanvasPopup, arg, i);
*/


	for(i=0;i<CFTable[max_layers-1];i++){
		sprintf(label, "     %d       ", i);
		RunningNodeAscLab[i]   = XtVaCreateManagedWidget(label,labelWidgetClass,RunningForm,NULL);
		RunningErrorAscBox[i]  = XtVaCreateManagedWidget(label,asciiTextWidgetClass,RunningForm,NULL);		
		RunningRateAscBox[i]   = XtVaCreateManagedWidget(label,asciiTextWidgetClass,RunningForm,NULL);
	}


	XtPopup( RunningPopup, XtGrabNonexclusive );
	XtPopup( RunningErrorCanvasPopup, XtGrabNonexclusive );
/*	XtPopup( RunningRateCanvasPopup, XtGrabNonexclusive );*/

/*	XtAddEventHandler( RunningErrorCanvasPopup, ButtonPressMask, FALSE, RunningSTOPEventHandler, (Opaque )NULL );
*/ 
}
/*
void	RunningSTOPEventHandler( Widget w, caddr_t unused, register XEvent *event)
{
	int	i, j;

	ProcAllocClean(pSER);
	ProcAllocClean(pINP);

	for(i=0;i<max_layers-2;i++)
               	for(j=0;j<CFTable[i+1];j++)
			ProcAllocClean(	pHL[i][j] );

	for(i=0;i<CFTable[max_layers-1];i++)
		ProcAllocClean(	pOUT[i] );
}

*/

void	RunningPopdownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int	i;

/*	XtPopdown( RunningRateCanvasPopup );*/
	
	XtPopdown( RunningErrorCanvasPopup );
	XtPopdown( RunningPopup );

        for(i=0;i<CFTable[max_layers-1];i++){
                XtDestroyWidget( RunningNodeAscLab[i] );
                XtDestroyWidget( RunningRateAscBox[i] );
                XtDestroyWidget( RunningErrorAscBox[i]);
        }
	free( RunningNodeAscLab );
        free( RunningRateAscBox );
        free( RunningErrorAscBox);

}


void	SetRandomValuesInNetwork( Widget W, XtPointer client_data, XtPointer call_data )
{
	Neuron	n = NULL;
	int 	i, j, k;

	if( (n=(Neuron )calloc(1, sizeof(struct NEURON) )) == NULL )
		ErrorHandler(75, MALLOC_ERROR, 0);

	for(i=0;i<max_layers;i++)
		for(j=0;j<CFTable[i];j++){
			if( (n=NCP[ GetRelativeOffset(i,j) ]) == NULL )
				ErrorHandler(75, CREATE_NEURON_NODE, 0);
			n->threshold = Random(MAX_THRESH);
			for(k=0;k<n->outnum;k++) (n->weight)[i] = Random(MAX_WEIGHT);
		        n->delta  = 0.0;
        		n->output = 0.0;
	}
}

			
void	RunningStartRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	FILE	*file;
        int i, j;
	Neuron  n = NULL;
	Process	***pHL, **pOUT,	*pINP, *pSER;
	char dummy[2], filename[70];
	double **target_data;
	Arg	arg[2];
	String	string;


	if( (n=(Neuron )calloc(1, sizeof(struct NEURON))) == NULL )
		ErrorHandler(72, MALLOC_ERROR, 5);

/* By that point the CFTable should be allocated and  filled up, and the max_layers known, this is done by the GetUserResponse() function */

	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(RunningItersAscLab, arg, 1);
	if( (max_iters=atoi(string)) == 0) max_iters = 50;
	
	XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), greengc, 0, (int )(ERROR_BOX_Y/2), ERROR_BOX_X, (int )(ERROR_BOX_Y/2) );

/* By that point the global array-variables are declared and some of them are initialised, now need to fill them up */
 

/* Allocate memory for a 2D array of size (max_layers-2 by #of nodes in each layer) to store the process to each hidden layer, pHL is a pointer to that list */
	if( (pHL=(Process ***)calloc(max_layers-2, sizeof(Process **))) == NULL )
		ErrorHandler(72, MALLOC_ERROR, 0);
	for(i=1;i<max_layers-1;i++)
		if( (pHL[i-1]=(Process **)calloc(CFTable[i], sizeof(Process *))) == NULL )
			 ErrorHandler(72, MALLOC_ERROR, 1);

/* Allocate memory for a 1D array of size num_outputs=CFTable[max_layers-1] to store all the processes of each output unit , pOUT is a pointer to that list */
	if( (pOUT=(Process **)calloc(CFTable[max_layers-1], sizeof(Process *))) == NULL )
                         ErrorHandler(72, MALLOC_ERROR, 2);

/* Allocate memory for a 1D array of size double to store all the targets for each output node */
	if( (target_data=(double **)calloc(CFTable[max_layers-1], sizeof(double *))) == NULL )
			ErrorHandler(72, MALLOC_ERROR, 3);
	for(i=0;i<CFTable[max_layers-1];i++) 
		if( (target_data[i]=(double *)calloc(num_exemplars, sizeof(double))) == NULL)
			ErrorHandler(72, MALLOC_ERROR, 4);

	
/* NOW PROCALLOC ALL THE PROCESS TOTAL NUMBER OF PROCESSES ARE:
			INP LAYER: 	1 
			HID LAYER:	(max_layers-2)*(nodes in each layer) ( (max_layers-2)*SumOf(CFTable[1..max_layers-2]) )
			OUT LAYER:	nodes in output layer( CFTable[max_layers-1] )
			TOTAL	 :	1 + (max_layers-2)*SumOf(CFTable[1..max_layers-2]) + CFTable[max_layers-1]
*/

/* Stack Size 1300 bytes worked OK but if something goes wrong this is most likely to be the cause*/
	if( (pINP=ProcAlloc(prIN,STACK_SIZE,2,LEARNING, NULL)) == NULL )
		ErrorHandler( 72, ALLOCATE_PROC, -1 );

	for(i=0;i<max_layers-2;i++)
		for(j=0;j<CFTable[i+1];j++)
			if( (pHL[i][j]=ProcAlloc( prHL, STACK_SIZE, 4, i+1, j, LEARNING, NULL )) == NULL )
				ErrorHandler( 72, ALLOCATE_PROC, i );


	for(i=0;i<CFTable[max_layers-1];i++){
		for(j=0;j<num_exemplars;j++)
			target_data[i][j] = Training[ j ].Target[ i ]; /* j=vector, i=node */

		if( (pOUT[i]=ProcAlloc(prOUT,2*STACK_SIZE,5, i, target_data[i], num_exemplars, LEARNING, NULL)) == NULL )
			ErrorHandler( 72, ALLOCATE_PROC, 200 );
	}

	if( (pSER=ProcAlloc(prSER,STACK_SIZE,3,LEARNING, Type[0], NULL)) == NULL )
		ErrorHandler( 72, ALLOCATE_PROC, 300 );


/* NOW RUN THE PROCESSES IN PARALLEL. GOD HELP US */
	ProcRun(pINP); /* Run the FeedInputs process */
	
	for(i=0;i<max_layers-2;i++)
                for(j=0;j<CFTable[i+1];j++){
/*			printf(" RUN HIDDEN: (%d,%d)= %p\n", i+1,j,pHL[i][j]);*/
			ProcRun( pHL[i][j] ); /* Run all the HiddenLayer processes */
	}

	for(i=0;i<CFTable[max_layers-1];i++)
		ProcRun(pOUT[i]); /* Run the OutputLayer process */
	ProcRun(pSER);
for(i=0;i<CFTable[max_layers-1];i++)	ChanInInt( message ); /* wait until the all the data has been processed */

        /* Clean Processes */
        ProcAllocClean(pINP);
	
        
        for(i=0;i<max_layers-2;i++){
                for(j=0;j<CFTable[i+1];j++)
                        ProcAllocClean(pHL[i][j] );
		free(pHL[i]);
	}
	free(pHL);

        for(i=0;i<CFTable[max_layers-1];i++)
                ProcAllocClean(pOUT[i]);
	free(pOUT);

        ProcAllocClean(pSER);
}



